VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "clsHighScore"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
'
'  Nibbles fr Windows
'
'  Copyright (C) 2000-2001 by Herfried K. Wagner.
'  Alle Rechte vorbehalten.
'
'  Sie sind berechtigt, die Anwendung in unvernderter Form zu kompilieren und im Eigengebrauch
'  zu verwenden, es wird dafr aber keine Haftung bernommen. Sie sind nicht berechtigt, den
'  Code in eigenen Programmen zu verwenden, ausser Sie holen sich vorher die schriftliche
'  Genehmigung des Autors ein. Weiters sind Sie nicht berechtigt, nderungen am Code vorzunehmen,
'  ausser diese dienen *nur* zum Eigengebrauch. Das Entfernen der Copyright-Hinweise ist nicht
'  gestattet. Ebenso darf das Programm bzw. Teile davon nicht auf Server geladen werden, auch die
'  Weitergabe des Codes ist nicht gestattet, es muss immer auf eine der folgenden Adressen
'  verwiesen werden:
'
'    http://www.ActiveVB.de
'    http://www.vbFun.de
'    http://beam.to/hirfhome
'
'  Bei Kommentaren, Fehlern oder Anregungen richten Sie bitte ein e-Mail an Hirf@ActiveVB.de.
'  Ich wnsche viel Spass mit diesem kleinen Spielchen ;-)
'
'**************************************************************************************************
'
'  Anzeigen von frmScore. Lesen und Speichern der Scores und Namen in die Windows-Registry.
'  Verwendet clsRegistry.
'
'**************************************************************************************************
Option Explicit

Private Type Score
    strName As String
    intScore As Integer     ' As String.
End Type

Private m_scrScores() As Score

Private m_intNumberPlaces As Integer
Private m_soScoreOrder As ScoreSystem

Public Enum ScoreSystem
    BiggerIsBetter = 0
    SmallerIsBetter = 1
End Enum

' Registrierungsschlssel fr die HighScore-Tabelle in HKEY_CURRENT_USER.
Private Const m_conRegSubKeyHighScore As String = "Software\HirfSoft\Nibbles\HighScore"

'
' Lesen der Scores.
'
Public Sub ReadScores()
    Dim intGetScore As Integer
    Dim strRegReadScore As String
    
    For intGetScore = 1 To m_intNumberPlaces
        
        ' Namen lesen.
        strRegReadScore = g_clsRegistry.RegGetValue(HKEY_CURRENT_USER, m_conRegSubKeyHighScore, "Name" & intGetScore)
        If strRegReadScore = "" Then
            m_scrScores(intGetScore).strName = "unbekannt"
        Else
            m_scrScores(intGetScore).strName = strRegReadScore
        End If
        
        ' Scores lesen.
        strRegReadScore = g_clsRegistry.RegGetValue(HKEY_CURRENT_USER, m_conRegSubKeyHighScore, "Score" & intGetScore)
        If strRegReadScore = "" Or Not IsNumeric(strRegReadScore) Then
            m_scrScores(intGetScore).intScore = "0"
        Else
            m_scrScores(intGetScore).intScore = strRegReadScore     ' Dezimalwert.
        End If
    Next intGetScore
End Sub

'
' Scores schreiben.
'
Public Sub WriteScores()
    Dim intPutScore As Integer
    
    For intPutScore = 1 To m_intNumberPlaces
        
        ' Scores schreiben.
        Call g_clsRegistry.RegSetDWord(HKEY_CURRENT_USER, m_conRegSubKeyHighScore, "Score" & intPutScore, m_scrScores(intPutScore).intScore)
        
        ' Namen schreiben.
        Call g_clsRegistry.RegSetString(HKEY_CURRENT_USER, m_conRegSubKeyHighScore, "Name" & intPutScore, m_scrScores(intPutScore).strName)
    Next intPutScore
End Sub

'
' Ausgabe der Scores.
'
Public Sub MakeScores(Optional ByVal intBiggestScore As Integer)
    Dim intMakeScore As Integer
    
    If intBiggestScore > m_intNumberPlaces Or IsEmpty(intBiggestScore) = True Or intBiggestScore = 0 Then intBiggestScore = m_intNumberPlaces
    
    ' Information in frmScore.
    frmScore.lblInfo.Caption = "Je " & IIf(m_soScoreOrder = BiggerIsBetter, "mehr", "weniger") & " Punkte desto besser."
    
    ' Schreiben der Scores.
    For intMakeScore = 1 To intBiggestScore
        With frmScore
            Load .lblPlace(intMakeScore)
            .lblPlace(intMakeScore).Caption = intMakeScore & "."
            .lblPlace(intMakeScore).Top = .lblPlace(intMakeScore - 1).Top + 300
            .lblPlace(intMakeScore).FontBold = False
            .lblPlace(intMakeScore).Visible = True
            
            Load .lblPoints(intMakeScore)
            .lblPoints(intMakeScore).Caption = m_scrScores(intMakeScore).intScore
            .lblPoints(intMakeScore).Top = .lblPoints(intMakeScore - 1).Top + 300
            .lblPoints(intMakeScore).FontBold = False
            .lblPoints(intMakeScore).Visible = True
            
            Load .lblName(intMakeScore)
            .lblName(intMakeScore).Caption = m_scrScores(intMakeScore).strName
            .lblName(intMakeScore).Top = .lblName(intMakeScore - 1).Top + 300
            .lblName(intMakeScore).FontBold = False
            .lblName(intMakeScore).Visible = True
        End With
    Next intMakeScore
    
    ' Anzeigen der Scores.
    frmScore.Show vbModal, frmMain
End Sub

'
' Scores einfgen.
'
Public Function InsertScores(ByRef strName As String, ByVal intScore As Integer) As Integer
    Dim intInsertScore As Integer, intUpdateScore As Integer
    
    If IIf(m_soScoreOrder = SmallerIsBetter, intScore > m_scrScores(m_intNumberPlaces).intScore, intScore < m_scrScores(m_intNumberPlaces).intScore) Then
        InsertScores = 0
        Exit Function
    End If
    
    For intInsertScore = 1 To m_intNumberPlaces
        If IIf(m_soScoreOrder = SmallerIsBetter, intScore < m_scrScores(intInsertScore).intScore, intScore > m_scrScores(intInsertScore).intScore) Then
            For intUpdateScore = m_intNumberPlaces - 1 To intInsertScore + 1 Step -1
                m_scrScores(intUpdateScore) = m_scrScores(intUpdateScore - 1)
            Next intUpdateScore
            
            m_scrScores(intInsertScore).strName = IIf(strName = "", "Anonymous", strName)
            m_scrScores(intInsertScore).intScore = intScore
            InsertScores = intInsertScore
            Exit For
        End If
    Next intInsertScore
End Function

'
' Scores zurcksetzen.
'
Public Sub ResetScores()
    Dim intResetScore As Integer
    
    For intResetScore = 1 To m_intNumberPlaces
        m_scrScores(intResetScore).strName = "unbekannt"
        m_scrScores(intResetScore).intScore = "1000"
    Next intResetScore
    
    Call WriteScores
End Sub

Public Property Get Name(ByVal intIndex As Integer) As String
    Name = m_scrScores(intIndex).strName
End Property

Public Property Let Name(ByVal intIndex As Integer, ByVal strNewValue As String)
    m_scrScores(intIndex).strName = strNewValue
End Property

Public Property Get Score(ByVal intIndex As Integer) As Integer
    Score = m_scrScores(intIndex).intScore
End Property

Public Property Let Score(ByVal intIndex As Integer, ByVal intNewValue As Integer)
    m_scrScores(intIndex).intScore = intNewValue
End Property

Public Property Get NumPlaces() As Integer
    NumPlaces = m_intNumberPlaces
End Property

Public Property Let NumPlaces(ByVal intNewValue As Integer)
    m_intNumberPlaces = intNewValue
    ReDim Preserve m_scrScores(1 To m_intNumberPlaces) As Score
End Property

Public Function BestScore()
    BestScore = m_scrScores(1).intScore
End Function

Public Function WorstScore()
    WorstScore = m_scrScores(m_intNumberPlaces).intScore
End Function

Public Property Get ScoreType() As ScoreSystem
    ScoreType = m_soScoreOrder
End Property

Public Property Let ScoreType(ByVal ssNewValue As ScoreSystem)
    m_soScoreOrder = ssNewValue
End Property
