VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "clsWorm"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
'
'  Nibbles fr Windows
'
'  Copyright (C) 2000-2001 by Herfried K. Wagner.
'  Alle Rechte vorbehalten.
'
'  Sie sind berechtigt, die Anwendung in unvernderter Form zu kompilieren und im Eigengebrauch
'  zu verwenden, es wird dafr aber keine Haftung bernommen. Sie sind nicht berechtigt, den
'  Code in eigenen Programmen zu verwenden, ausser Sie holen sich vorher die schriftliche
'  Genehmigung des Autors ein. Weiters sind Sie nicht berechtigt, nderungen am Code vorzunehmen,
'  ausser diese dienen *nur* zum Eigengebrauch. Das Entfernen der Copyright-Hinweise ist nicht
'  gestattet. Ebenso darf das Programm bzw. Teile davon nicht auf Server geladen werden, auch die
'  Weitergabe des Codes ist nicht gestattet, es muss immer auf eine der folgenden Adressen
'  verwiesen werden:
'
'    http://www.ActiveVB.de
'    http://www.vbFun.de
'    http://beam.to/hirfhome
'
'  Bei Kommentaren, Fehlern oder Anregungen richten Sie bitte ein e-Mail an Hirf@ActiveVB.de.
'  Ich wnsche viel Spass mit diesem kleinen Spielchen ;-)
'
'**************************************************************************************************
'
'  Worm class module.
'
'  This class module in not really independent which means that some procs and controls on
'  frmMain are needed.
'
'**************************************************************************************************
Option Explicit

Private Const m_conIntWormStartSize As Integer = 4      ' Worm start length.
Private Const m_conIntWormStartLives As Integer = 3     ' Start lives.

' Data for body segments.
Private Type BodyData
    intLeft As Integer
    intTop As Integer
    intIndexAhead As Integer
End Type

'
' We need some extra logic to resize the worm correctly.
'
Private m_bdBodyData(0 To 93) As BodyData    ' Worm len can max. be 93 pieces.

Private m_intFirst As Integer       ' Index of first bodysegment.
Private m_intLast As Integer        ' Index of last bodysegment.
Private m_intResizeIndex As Integer

' Position of the worm's head.
Public m_intHeadLeft As Integer
Public m_intHeadTop As Integer

' Module-level member variables used to hold properties data.
Private m_intLives As Integer
Private m_intScore As Integer
Private m_strPlayerName As String
Private m_dirDirection As Direction
Private m_intNoSegments As Integer
Private m_blnDead As Boolean
Private m_blnGameOver As Boolean

' The worm's number, used to identify each worm (e.g. for crash check).
Private m_intWormNumber As Integer

Private m_intStartPositionX As Integer
Private m_intStartPositionY As Integer
Private m_dirStartDirection As Direction

'===================================
' Class properties.
'===================================

'
' Dead.
'
' Gibt an, ob der Wurm tot ist. Wird bei jeder neuen Runde bzw. neuem Level auf False gesetzt.
'
Public Property Get Dead() As Boolean
    Dead = m_blnDead
End Property

Public Property Let Dead(ByVal blnNewDead As Boolean)
    m_blnDead = blnNewDead
    
    If blnNewDead = True Then Call RemoveWorm
End Property

'
' GameOver.
'
' Gibt an, ob ein Wurm nicht mehr im aktuellen Spiel mitspielt, weil er 0 Lives hat.
'
Public Property Get GameOver() As Boolean
    GameOver = m_blnGameOver
End Property

Public Property Let GameOver(ByVal blnNewGameOver As Boolean)
    m_blnGameOver = blnNewGameOver
    
    If blnNewGameOver = True Then
        Call RemoveWorm
        frmMain.lblLives(m_intWormNumber - 1).ForeColor = &HC0&
    Else
        frmMain.lblLives(m_intWormNumber - 1).ForeColor = vbWhite
    End If
End Property

'
' WormNumber (ID).
'
' Eine Nummer, die als ID zur Identifikation des Wurms verwendet wird, jeder Wurm hat eine andere
' ID.
'
Public Property Get WormNumber() As Integer
    WormNumber = m_intWormNumber
End Property

Public Property Let WormNumber(ByVal intNewWormNumber As Integer)
    m_intWormNumber = intNewWormNumber
End Property

'
' Direction
'
' Richtung, in die sich der Wurm bewegt.
'
Public Property Get Direction() As Direction
    Direction = m_dirDirection
End Property

Public Property Let Direction(ByVal dirNewDirection As Direction)
    m_dirDirection = dirNewDirection
End Property

'
' Lives.
'
Public Property Get Lives() As Integer
    Lives = m_intLives
End Property

Public Property Let Lives(ByVal intNewLives As Integer)
    m_intLives = intNewLives
    
    If intNewLives = 0 Then GameOver = True
    
    ' Update.
    frmMain.lblLives(m_intWormNumber - 1).Caption = Format$(intNewLives, "00")
End Property

'
' Score.
'
' This property is variant because the Let procedure MUST be Variant to support values like 64000...
'
Public Property Get Score() As Variant
    Score = m_intScore
End Property

Public Property Let Score(ByVal vntNewScore As Variant)     ' Variant!
    Dim intNewScore As Integer
    
    If vntNewScore >= -32767 And vntNewScore <= 32767 Then
        intNewScore = CInt(vntNewScore)
    Else
        intNewScore = IIf(vntNewScore > 0, 32767, -32767)
    End If
    
    m_intScore = intNewScore
    
    ' Update.
    frmMain.lblScore(m_intWormNumber - 1).Caption = Format$(intNewScore, "0000")
End Property

'
' PlayerName.
'
Public Property Get PlayerName() As String
    PlayerName = m_strPlayerName
End Property

Public Property Let PlayerName(ByVal strNewPlayerName As String)
    m_strPlayerName = strNewPlayerName
    
    ' Update (format name to fit the label).
    frmMain.lblName(m_intWormNumber - 1).Caption = IIf(Len(strNewPlayerName) > 12, RTrim$(Left$(strNewPlayerName, 10)) & "...", strNewPlayerName)
End Property

'===================================
' Class methods.
'===================================

'
' Initializes a worm (SetWormStartPos MUST be called first).
'
Public Sub InitWorm()
    
    ' Reset props.
    Lives = m_conIntWormStartLives
    Score = 0
    
    ' Dead and GameOver will be set to False in ShowInitialWorm.
    
    ' Show initial worm.
    Call ShowInitWorm
End Sub

'
' Paints the initial worm at the worm's start position.
'
Public Sub ShowInitWorm()
    Dim i As Integer, j As Integer
    
    m_intNoSegments = 0
    m_intFirst = 0
    m_intLast = 0
    m_intResizeIndex = 0
    
    ' Place the head.
    m_intHeadLeft = m_intStartPositionX
    m_intHeadTop = m_intStartPositionY
    
    Call PlaceHead(m_intHeadLeft, m_intHeadTop)
    
    ' Place the first body segment.
    Select Case m_dirStartDirection
        Case dirLeft
            m_bdBodyData(0).intLeft = m_intHeadLeft + 1
            m_bdBodyData(0).intTop = m_intHeadTop
        Case dirRight
            m_bdBodyData(0).intLeft = m_intHeadLeft - 1
            m_bdBodyData(0).intTop = m_intHeadTop
        Case dirUp
            m_bdBodyData(0).intLeft = m_intHeadLeft
            m_bdBodyData(0).intTop = m_intHeadTop + 1
        Case dirDown
            m_bdBodyData(0).intLeft = m_intHeadLeft
            m_bdBodyData(0).intTop = m_intHeadTop - 1
    End Select
    
    Call PlaceBody(m_bdBodyData(0).intLeft, m_bdBodyData(0).intTop)
    
    ' Place the rest of the "init worm".
    For i = 1 To m_conIntWormStartSize - 1
        Select Case m_dirStartDirection
            Case dirLeft
                m_bdBodyData(i).intLeft = m_bdBodyData(0).intLeft + i
                m_bdBodyData(i).intTop = m_bdBodyData(0).intTop
            Case dirRight
                m_bdBodyData(i).intLeft = m_bdBodyData(0).intLeft - i
                m_bdBodyData(i).intTop = m_bdBodyData(0).intTop
            Case dirUp
                m_bdBodyData(i).intLeft = m_bdBodyData(0).intLeft
                m_bdBodyData(i).intTop = m_bdBodyData(0).intTop + i
            Case dirDown
                m_bdBodyData(i).intLeft = m_bdBodyData(0).intLeft
                m_bdBodyData(i).intTop = m_bdBodyData(0).intTop - i
        End Select
        
        Call PlaceBody(m_bdBodyData(i).intLeft, m_bdBodyData(i).intTop)
        m_bdBodyData(i).intIndexAhead = i - 1
    Next i
    
    ' Start values.
    m_dirDirection = m_dirStartDirection
    m_intFirst = 0
    m_intLast = m_conIntWormStartSize - 1
    m_intNoSegments = m_intLast
    
    Dead = False
    GameOver = False
End Sub

'
' MoveWorm (alias the app's most important sub).
'
Public Sub MoveWorm()
    If Dead Then Exit Sub   ' Remove dead worm...
    
    Dim i As Integer
    
    ' Paint black over last bodysegment.
    If m_intResizeIndex = 0 Then Call RemoveBody(m_bdBodyData(m_intLast).intLeft, m_bdBodyData(m_intLast).intTop)
    
    ' Then draw the new segments.
    For i = 1 To m_intResizeIndex
        m_intNoSegments = m_intNoSegments + 1
        m_bdBodyData(m_intNoSegments).intLeft = m_bdBodyData(m_intLast).intLeft
        m_bdBodyData(m_intNoSegments).intTop = m_bdBodyData(m_intLast).intTop
        Call PlaceBody(m_bdBodyData(m_intNoSegments).intLeft, m_bdBodyData(m_intNoSegments).intTop)
        m_bdBodyData(m_intNoSegments).intIndexAhead = m_intLast
        m_intLast = m_intNoSegments
    Next i
    
    m_intResizeIndex = 0
    
    ' Move the last body segment to the heads position.
    m_bdBodyData(m_intLast).intLeft = m_intHeadLeft
    m_bdBodyData(m_intLast).intTop = m_intHeadTop
    Call PlaceBody(m_bdBodyData(m_intLast).intLeft, m_bdBodyData(m_intLast).intTop)
    
    ' Change direction by moving the head to its new position.
    Select Case m_dirDirection
        Case dirLeft:   m_intHeadLeft = m_intHeadLeft - 1
        Case dirRight:  m_intHeadLeft = m_intHeadLeft + 1
        Case dirDown:   m_intHeadTop = m_intHeadTop + 1
        Case dirUp:     m_intHeadTop = m_intHeadTop - 1
    End Select
    
    ' //
    ' // Check if we crash a wall.
    ' //
    If _
        g_unPlayingField(m_intHeadLeft, m_intHeadTop).intWormOver = m_intWormNumber Or _
        g_unPlayingField(m_intHeadLeft, m_intHeadTop).blnIsWall _
    Then
        
        ' Minus 1 life.
        m_intLives = m_intLives - 1
        frmMain.lblLives(m_intWormNumber - 1).Caption = CStr(Format$(m_intLives, "00"))
        Score = Score - 100 * g_intLevel
        
        Dead = True
        Call Crash
        
        Exit Sub
    End If
    
    ' //
    ' // Check if there is a worm crash.
    ' //
    If g_intNumPlayers = 2 Then
        If _
            g_unPlayingField(m_intHeadLeft, m_intHeadTop).intWormOver <> m_intWormNumber And _
            g_unPlayingField(m_intHeadLeft, m_intHeadTop).intWormOver <> 0 _
        Then
            Call PlaceHead(m_intHeadLeft, m_intHeadTop)
            #If UseVBTimer Then
                frmMain.tmrTimer.Enabled = False
            #Else
                Call DisableTimer
            #End If
            Call DisplayMessage("Kill", "Kill by " & m_strPlayerName & "!")
            Call Sleep(0.6)
            
            Call WormCrash
            
            #If UseVBTimer Then
                
                ' Reduce worm's score because the worm killed the other one. He must be punished!
                Score = Score - ((100 - frmMain.tmrTimer.Interval) / 10) * 100
            #Else
                
                ' Reduce worm's score because the worm killed the other one. He must be punished!
                Score = Score - ((100 - GetInterval) / 10) * 100
            #End If
            
            ' Restart level.
            Call ResetRound
            
            Exit Sub
        End If
    End If
    
    ' //
    ' // Check if we eat the food.
    ' //
    If _
        (m_intHeadLeft - g_intFoodLeft < 1) And _
        (m_intHeadLeft - g_intFoodLeft >= 0) And _
        (m_intHeadTop - g_intFoodTop < 1) And _
        (m_intHeadTop - g_intFoodTop) >= 0 _
    Then
        If frmMain.mnuGameSound.Checked = True Then Call PlayWaveResource("eat")
        g_intNumFood = g_intNumFood + 1
        
        Call RemoveFood     ' Remove old food.
        Call PlaceHead(m_intHeadLeft, m_intHeadTop)
        
        #If UseVBTimer Then
            
            ' Score erhhen, je nach Intervall des Timers.
            Score = Score + CInt((100 - frmMain.tmrTimer.Interval) / 10) * g_intNumFood
        #Else
            
            ' Score erhhen, je nach Intervall des Timers.
            Score = Score + CInt((100 - GetInterval) / 10) * g_intNumFood
        #End If
        
        m_intResizeIndex = g_intNumFood * 2
        
        ' Wenn alle 10 dieses Levels eingesammelt.
        If g_intNumFood = 10 Then
            
            ' Wenn alle 10 Levels gespielt wurden, "Winner!"-Meldung anzeigen.
            If g_intLevel = g_conIntNumLevels Then
                #If UseVBTimer Then
                    frmMain.tmrTimer.Enabled = False    ' ***
                #Else
                    Call DisableTimer
                #End If
                
                If g_intNumPlayers = 1 Then
                    Call DisplayMessage("Game Over", "Sie haben gewonnen!")
                Else
                    Call DisplayMessage("Game Over", PlayerName & " hat gewonnen!")
                End If
                Call AddToScores
                
                Exit Sub
            End If   ' g_intLevel = g_conIntNumLevels
            
            #If UseVBTimer Then
                frmMain.tmrTimer.Enabled = False
            #Else
                Call DisableTimer
            #End If
            
            Call DisplayMessage("Game", "Level Complete!")
            Call Sleep(0.6)
            
            ' Ein Leben dazugeben.
            m_intLives = m_intLives + 1
            frmMain.lblLives(m_intWormNumber - 1).Caption = CStr(Format$(m_intLives, "00"))
            
            Call NextLevel
            
            Exit Sub
        End If   ' g_intNumFood = 10
        
        Call ShowNextFood   ' Show the next food.
    End If   ' Food is eaten...
    
    ' Place head.
    Call PlaceHead(m_intHeadLeft, m_intHeadTop)
    
    ' Update data for body segments.
    m_bdBodyData(m_intFirst).intIndexAhead = m_intLast
    m_intFirst = m_intLast
    m_intLast = m_bdBodyData(m_intLast).intIndexAhead
End Sub

Public Sub Reset()
    Call ShowInitWorm
End Sub

'
' Sets the worm's start position.
'
Public Sub SetWormStartPos(intLeft As Integer, intTop As Integer, dirDirection As Direction)
    m_intStartPositionX = intLeft
    m_intStartPositionY = intTop
    m_dirStartDirection = dirDirection
End Sub

'
' Removes the worm's body. This sub is called when a worm dies.
'
Public Sub RemoveWorm()
    Dim i As Integer, j As Integer
    
    For i = 0 To g_conSizeX
        For j = 0 To g_conSizeY
            If g_unPlayingField(i, j).intWormOver = m_intWormNumber Then
                Call RemoveBody(i, j)
            End If
        Next j
    Next i
End Sub

'===============================
' Local subs/functions.
'===============================

'
' Body.
'
Private Function PlaceBody(ByVal lngLeft As Long, ByVal lngTop As Long) As Long
    g_unPlayingField(lngLeft, lngTop).intWormOver = m_intWormNumber
    PlaceBody = BitBlt(frmMain.picField.hdc, lngLeft * g_intLengthUnit, lngTop * g_intLengthUnit, g_intLengthUnit, g_intLengthUnit, frmMain.picBody.hdc, 0, 0, SRCCOPY)
End Function

Private Function RemoveBody(ByVal lngLeft As Long, ByVal lngTop As Long) As Long
    g_unPlayingField(lngLeft, lngTop).intWormOver = 0
    RemoveBody = BitBlt(frmMain.picField.hdc, lngLeft * g_intLengthUnit, lngTop * g_intLengthUnit, g_intLengthUnit, g_intLengthUnit, frmMain.picRemove.hdc, 0, 0, SRCCOPY)
End Function

'
' Head.
'
Private Function PlaceHead(ByVal lngLeft As Long, ByVal lngTop As Long) As Long
    g_unPlayingField(lngLeft, lngTop).intWormOver = m_intWormNumber
    PlaceHead = BitBlt(frmMain.picField.hdc, lngLeft * g_intLengthUnit, lngTop * g_intLengthUnit, g_intLengthUnit, g_intLengthUnit, frmMain.picHead(m_intWormNumber - 1).hdc, 0, 0, SRCCOPY)
End Function
