Attribute VB_Name = "modWinStyles"
'
'  Nibbles fr Windows
'
'  Copyright (C) 2000-2001 by Herfried K. Wagner.
'  Alle Rechte vorbehalten.
'
'  Sie sind berechtigt, die Anwendung in unvernderter Form zu kompilieren und im Eigengebrauch
'  zu verwenden, es wird dafr aber keine Haftung bernommen. Sie sind nicht berechtigt, den
'  Code in eigenen Programmen zu verwenden, ausser Sie holen sich vorher die schriftliche
'  Genehmigung des Autors ein. Weiters sind Sie nicht berechtigt, nderungen am Code vorzunehmen,
'  ausser diese dienen *nur* zum Eigengebrauch. Das Entfernen der Copyright-Hinweise ist nicht
'  gestattet. Ebenso darf das Programm bzw. Teile davon nicht auf Server geladen werden, auch die
'  Weitergabe des Codes ist nicht gestattet, es muss immer auf eine der folgenden Adressen
'  verwiesen werden:
'
'    http://www.ActiveVB.de
'    http://www.vbFun.de
'    http://beam.to/hirfhome
'
'  Bei Kommentaren, Fehlern oder Anregungen richten Sie bitte ein e-Mail an Hirf@ActiveVB.de.
'  Ich wnsche viel Spass mit diesem kleinen Spielchen ;-)
'
'**************************************************************************************************
'
'  Little wrapper module for quick change of window style bits.
'
'**************************************************************************************************
Option Explicit

Private Declare Function SetWindowPos Lib "user32" (ByVal hwnd As Long, ByVal hWndInsertAfter As Long, ByVal x As Long, ByVal y As Long, ByVal cx As Long, ByVal cy As Long, ByVal wFlags As Long) As Long

Private Const SWP_FRAMECHANGED = &H20       ' The frame changed: send WM_NCCALCSIZE.
Private Const SWP_NOACTIVATE = &H10
Private Const SWP_NOMOVE = &H2
Private Const SWP_NOOWNERZORDER = &H200     ' Don't do owner Z ordering.
Private Const SWP_NOREDRAW = &H8
Private Const SWP_NOSIZE = &H1
Private Const SWP_NOZORDER = &H4
Private Const SWP_SHOWWINDOW = &H40

Public Declare Function SetWindowLong Lib "user32" Alias "SetWindowLongA" (ByVal hwnd As Long, ByVal nIndex As Long, ByVal dwNewLong As Long) As Long
Public Declare Function GetWindowLong Lib "user32" Alias "GetWindowLongA" (ByVal hwnd As Long, ByVal nIndex As Long) As Long

Public Const GWL_STYLE = (-16)

Public Const WS_THICKFRAME = &H40000
Public Const WS_BORDER = &H800000
Public Const WS_CAPTION = &HC00000

Public Const GWL_EXSTYLE = (-20)

Public Const WS_EX_WINDOWEDGE = &H100&
Public Const WS_EX_CLIENTEDGE = &H200&
Public Const WS_EX_STATICEDGE = &H20000

Public Enum WinStyleType
    wstStyle = GWL_STYLE
    wstExStyle = GWL_EXSTYLE
End Enum

Public Sub SetWinStyle(ByVal lnghWnd As Long, ByVal wstType As WinStyleType, ByVal lngStyles As Long)
    Call SetWindowLong(lnghWnd, wstType, lngStyles)
    Call SetWindowPos(lnghWnd, 0, 0, 0, 0, 0, SWP_NOMOVE Or SWP_NOSIZE Or SWP_NOOWNERZORDER Or SWP_NOZORDER Or SWP_FRAMECHANGED)
End Sub

Public Sub AddWinStyle(ByVal lnghWnd As Long, ByVal wstType As WinStyleType, ByVal lngStylesToAdd As Long)
    Call SetWindowLong(lnghWnd, wstType, GetWindowLong(lnghWnd, wstType) Or lngStylesToAdd)
    Call SetWindowPos(lnghWnd, 0, 0, 0, 0, 0, SWP_NOMOVE Or SWP_NOSIZE Or SWP_NOOWNERZORDER Or SWP_NOZORDER Or SWP_FRAMECHANGED)
End Sub

Public Sub RemoveWinStyle(ByVal lnghWnd As Long, ByVal wstType As WinStyleType, ByVal lngStylesToAdd As Long)
    Call SetWindowLong(lnghWnd, wstType, GetWindowLong(lnghWnd, wstType) And Not lngStylesToAdd)
    Call SetWindowPos(lnghWnd, 0, 0, 0, 0, 0, SWP_NOMOVE Or SWP_NOSIZE Or SWP_NOOWNERZORDER Or SWP_NOZORDER Or SWP_FRAMECHANGED)
End Sub
